﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using WebSiteAdminTool.UI.Views.Base;

namespace WebSiteAdminTool.UI.Services.Navigation
{
    public interface INavigationService
    {
        //void Navigate(string url);
        //void Back();

        // common navigation destinations
        ICommand NavigateBackCommand { get; }
        ICommand NavigateHomeCommand { get; }
        ICommand NavigateToAboutCommand { get; }
        // security navigation commands
        ICommand NavigateToUserManagementCommand { get; }
        ICommand NavigateToRoleManagementCommand { get; }
        ICommand NavigateToUserProfileManagementCommand { get; }
        ICommand NavigateToAccessRuleManagementCommand { get; }
        
        // helpers
        Uri GetPageUri<T>() where T : BaseNavigationPage;
    }
}
