﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using WebSiteAdminTool.UI.Utils.Commands;
using System.Linq;
using WebSiteAdminTool.UI.Views.Security;
using WebSiteAdminTool.UI.Services;
using System.ComponentModel;
using GalaSoft.MvvmLight.Messaging;
using GalaSoft.MvvmLight;
using WebSiteAdminTool.UI.Utils.Interfaces;
using WebSiteAdminTool.UI.Services.Navigation;
using WebSiteAdminTool.UI.Ioc;

namespace WebSiteAdminTool.UI.ViewModels.Base
{
    public abstract class BaseNavigableViewModel : BaseViewModel, INavigable
    {
        #region private data

        INavigationService _navigationService = null;

        #endregion

        #region ctors

        public BaseNavigableViewModel()
        {
            _navigationService = Factory.ServiceLocator.NavigationService;
        }

        #endregion

        #region INavigable implementation

        public INavigationService NavigationService
        {
            get
            {
                return _navigationService;
            }
        }

        #endregion
    }
}
