﻿using System;
using System.Net;
using Ninject.Modules;
using WebSiteAdminTool.Web.DataAccess.Interfaces;
using WebSiteAdminTool.Web.DataAccess;
using WebSiteAdminTool.Web.ConfigManager.Interfaces;
using WebSiteAdminTool.Web.ConfigManager;

namespace WebSiteAdminTool.Web.Ioc.Mappings
{
    public class RunTimeMappings : NinjectModule
    {
        public override void Load()
        {
            //Bind<IMainViewModel>().To<MainViewModel>().InSingletonScope();
            //Bind<IUserViewModel>().To<UserViewModel>();
            //Bind<IProductViewModel>().To<ProductViewModel>();

            // ------------------------------------ Data Access ------------------------------------------------------
            Bind<IMembershipDataAccess>().To<MembershipDataAccess>();
            Bind<IRolesDataAccess>().To<RolesDataAccess>();
            // ------------------------------------ Config Manager ------------------------------------------------------
            Bind<IMembershipConfigManager>().To<MembershipConfigManager>();
            Bind<IRolesConfigManager>().To<RolesConfigManager>();
        }
    }
}
